Index: src/aubio.h
===================================================================
--- src/aubio.h	(revision 52b5f34a17f85e61db57d23ab0b3c6489da862bb)
+++ src/aubio.h	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
@@ -194,4 +194,5 @@
 #include "io/source_sndfile.h"
 #include "io/source_apple_audio.h"
+#include "io/source_avcodec.h"
 #include "io/sink_sndfile.h"
 #include "io/sink_apple_audio.h"
Index: src/io/source.c
===================================================================
--- src/io/source.c	(revision 52b5f34a17f85e61db57d23ab0b3c6489da862bb)
+++ src/io/source.c	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
@@ -24,4 +24,7 @@
 #include "fmat.h"
 #include "io/source.h"
+#ifdef HAVE_AVCODEC
+#include "io/source_avcodec.h"
+#endif /* HAVE_AVCODEC */
 #ifdef __APPLE__
 #include "io/source_apple_audio.h"
@@ -29,21 +32,61 @@
 #ifdef HAVE_SNDFILE
 #include "io/source_sndfile.h"
-#endif
+#endif /* HAVE_SNDFILE */
+
+typedef void (*aubio_source_do_t)(aubio_source_t * s, fvec_t * data, uint_t * read);
+typedef void (*aubio_source_do_multi_t)(aubio_source_t * s, fmat_t * data, uint_t * read);
+typedef uint_t (*aubio_source_get_samplerate_t)(aubio_source_t * s);
+typedef uint_t (*aubio_source_get_channels_t)(aubio_source_t * s);
+typedef uint_t (*aubio_source_seek_t)(aubio_source_t * s, uint_t seek);
+typedef uint_t (*del_aubio_source_t)(aubio_source_t * s);
 
 struct _aubio_source_t { 
   void *source;
+  aubio_source_do_t s_do;
+  aubio_source_do_multi_t s_do_multi;
+  aubio_source_get_samplerate_t s_get_samplerate;
+  aubio_source_get_channels_t s_get_channels;
+  aubio_source_seek_t s_seek;
+  del_aubio_source_t s_del;
 };
 
 aubio_source_t * new_aubio_source(char_t * uri, uint_t samplerate, uint_t hop_size) {
   aubio_source_t * s = AUBIO_NEW(aubio_source_t);
+#if HAVE_AVCODEC
+  s->source = (void *)new_aubio_source_avcodec(uri, samplerate, hop_size);
+  if (s->source) {
+    s->s_do = (aubio_source_do_t)(aubio_source_avcodec_do);
+    s->s_do_multi = (aubio_source_do_multi_t)(aubio_source_avcodec_do_multi);
+    s->s_get_channels = (aubio_source_get_channels_t)(aubio_source_avcodec_get_channels);
+    s->s_get_samplerate = (aubio_source_get_samplerate_t)(aubio_source_avcodec_get_samplerate);
+    s->s_seek = (aubio_source_seek_t)(aubio_source_avcodec_seek);
+    s->s_del = (del_aubio_source_t)(del_aubio_source_avcodec);
+    return s;
+  }
+#endif /* HAVE_AVCODEC */
 #ifdef __APPLE__
   s->source = (void *)new_aubio_source_apple_audio(uri, samplerate, hop_size);
-  if (s->source) return s;
-#else /* __APPLE__ */
+  if (s->source) {
+    s->s_do = (aubio_source_do_t)(aubio_source_apple_audio_do);
+    s->s_do_multi = (aubio_source_do_multi_t)(aubio_source_apple_audio_do_multi);
+    s->s_get_channels = (aubio_source_get_channels_t)(aubio_source_apple_audio_get_channels);
+    s->s_get_samplerate = (aubio_source_get_samplerate_t)(aubio_source_apple_audio_get_samplerate);
+    s->s_seek = (aubio_source_seek_t)(aubio_source_apple_audio_seek);
+    s->s_del = (del_aubio_source_t)(del_aubio_source_apple_audio);
+    return s;
+  }
+#endif /* __APPLE__ */
 #if HAVE_SNDFILE
   s->source = (void *)new_aubio_source_sndfile(uri, samplerate, hop_size);
-  if (s->source) return s;
+  if (s->source) {
+    s->s_do = (aubio_source_do_t)(aubio_source_sndfile_do);
+    s->s_do_multi = (aubio_source_do_multi_t)(aubio_source_sndfile_do_multi);
+    s->s_get_channels = (aubio_source_get_channels_t)(aubio_source_sndfile_get_channels);
+    s->s_get_samplerate = (aubio_source_get_samplerate_t)(aubio_source_sndfile_get_samplerate);
+    s->s_seek = (aubio_source_seek_t)(aubio_source_sndfile_seek);
+    s->s_del = (del_aubio_source_t)(del_aubio_source_sndfile);
+    return s;
+  }
 #endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
   AUBIO_ERROR("failed creating aubio source with %s\n", uri);
   AUBIO_FREE(s);
@@ -52,62 +95,26 @@
 
 void aubio_source_do(aubio_source_t * s, fvec_t * data, uint_t * read) {
-#ifdef __APPLE__
-  aubio_source_apple_audio_do((aubio_source_apple_audio_t *)s->source, data, read);
-#else /* __APPLE__ */
-#if HAVE_SNDFILE
-  aubio_source_sndfile_do((aubio_source_sndfile_t *)s->source, data, read);
-#endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
+  s->s_do((void *)s->source, data, read);
 }
 
 void aubio_source_do_multi(aubio_source_t * s, fmat_t * data, uint_t * read) {
-#ifdef __APPLE__
-  aubio_source_apple_audio_do_multi((aubio_source_apple_audio_t *)s->source, data, read);
-#else /* __APPLE__ */
-#if HAVE_SNDFILE
-  aubio_source_sndfile_do_multi((aubio_source_sndfile_t *)s->source, data, read);
-#endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
+  s->s_do_multi((void *)s->source, data, read);
 }
 
 void del_aubio_source(aubio_source_t * s) {
   if (!s) return;
-#ifdef __APPLE__
-  del_aubio_source_apple_audio((aubio_source_apple_audio_t *)s->source);
-#else /* __APPLE__ */
-#if HAVE_SNDFILE
-  del_aubio_source_sndfile((aubio_source_sndfile_t *)s->source);
-#endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
+  s->s_del((void *)s->source);
   AUBIO_FREE(s);
 }
 
 uint_t aubio_source_get_samplerate(aubio_source_t * s) {
-#ifdef __APPLE__
-  return aubio_source_apple_audio_get_samplerate((aubio_source_apple_audio_t *)s->source);
-#else /* __APPLE__ */
-#if HAVE_SNDFILE
-  return aubio_source_sndfile_get_samplerate((aubio_source_sndfile_t *)s->source);
-#endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
+  return s->s_get_samplerate((void *)s->source);
 }
 
 uint_t aubio_source_get_channels(aubio_source_t * s) {
-#ifdef __APPLE__
-  return aubio_source_apple_audio_get_channels((aubio_source_apple_audio_t *)s->source);
-#else /* __APPLE__ */
-#if HAVE_SNDFILE
-  return aubio_source_sndfile_get_channels((aubio_source_sndfile_t *)s->source);
-#endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
+  return s->s_get_channels((void *)s->source);
 }
 
 uint_t aubio_source_seek (aubio_source_t * s, uint_t seek ) {
-#ifdef __APPLE__
-  return aubio_source_apple_audio_seek ((aubio_source_apple_audio_t *)s->source, seek);
-#else /* __APPLE__ */
-#if HAVE_SNDFILE
-  return aubio_source_sndfile_seek ((aubio_source_sndfile_t *)s->source, seek);
-#endif /* HAVE_SNDFILE */
-#endif /* __APPLE__ */
+  return s->s_seek((void *)s->source, seek);
 }
Index: src/io/source_avcodec.c
===================================================================
--- src/io/source_avcodec.c	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
+++ src/io/source_avcodec.c	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
@@ -0,0 +1,372 @@
+/*
+  Copyright (C) 2013 Paul Brossier <piem@aubio.org>
+
+  This file is part of aubio.
+
+  aubio is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
+
+  aubio is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with aubio.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+
+#include "config.h"
+
+#ifdef HAVE_AVCODEC
+
+#include <sndfile.h>
+#include <libavcodec/avcodec.h>
+#include <libavformat/avformat.h>
+#include <libavresample/avresample.h>
+#include <libavutil/opt.h>
+#include <stdlib.h>
+
+#include "aubio_priv.h"
+#include "fvec.h"
+#include "fmat.h"
+#include "source_avcodec.h"
+
+#define AUBIO_AVCODEC_MIN_BUFFER_SIZE FF_MIN_BUFFER_SIZE
+
+#define SHORT_TO_FLOAT(x) (smpl_t)(x * 3.0517578125e-05)
+
+struct _aubio_source_avcodec_t {
+  uint_t hop_size;
+  uint_t samplerate;
+  uint_t channels;
+
+  // some data about the file
+  char_t *path;
+  uint_t input_samplerate;
+  uint_t input_channels;
+
+  // avcodec stuff
+  AVFormatContext *avFormatCtx;
+  AVCodecContext *avCodecCtx;
+  AVFrame *avFrame;
+  AVAudioResampleContext *avr;
+  int16_t *output;
+  uint_t read_samples;
+  uint_t read_index;
+  sint_t selected_stream;
+  uint_t eof;
+};
+
+aubio_source_avcodec_t * new_aubio_source_avcodec(char_t * path, uint_t samplerate, uint_t hop_size) {
+  aubio_source_avcodec_t * s = AUBIO_NEW(aubio_source_avcodec_t);
+  int err;
+
+  if (path == NULL) {
+    AUBIO_ERR("Aborted opening null path\n");
+    return NULL;
+  }
+
+  s->hop_size = hop_size;
+  s->channels = 1;
+  s->path = path;
+
+  // register all formats and codecs
+  av_register_all();
+
+  // if path[0] != '/'
+  //avformat_network_init();
+
+  // try opening the file and get some info about it
+  AVFormatContext *avFormatCtx = s->avFormatCtx;
+  avFormatCtx = NULL;
+  if ( (err = avformat_open_input(&avFormatCtx, s->path, NULL, NULL) ) < 0 ) {
+    uint8_t errorstr_len = 128;
+    char errorstr[errorstr_len];
+    if (av_strerror (err, errorstr, errorstr_len) == 0) {
+      AUBIO_ERR("Failed opening %s (%s)\n", s->path, errorstr);
+    } else {
+      AUBIO_ERR("Failed opening %s (unknown error)\n", s->path);
+    }
+    goto beach;
+  }
+
+  // try to make sure max_analyze_duration is big enough for most songs
+  avFormatCtx->max_analyze_duration *= 100;
+
+  // retrieve stream information
+  if ( (err = avformat_find_stream_info(avFormatCtx, NULL)) < 0 ) {
+    uint8_t errorstr_len = 128;
+    char errorstr[errorstr_len];
+    if (av_strerror (err, errorstr, errorstr_len) == 0) {
+      AUBIO_ERR("Could not find stream information for %s (%s)\n", s->path, errorstr);
+    } else {
+      AUBIO_ERR("Could not find stream information for %s (unknown error)\n", s->path);
+    }
+    goto beach;
+  }
+
+  // Dump information about file onto standard error
+  //av_dump_format(avFormatCtx, 0, s->path, 0);
+
+  // look for the first audio stream, printing a warning if more than one is found
+  uint_t i;
+  sint_t selected_stream = -1;
+  for (i = 0; i < avFormatCtx->nb_streams; i++) {
+    if (avFormatCtx->streams[i]->codec->codec_type == AVMEDIA_TYPE_AUDIO) {
+      if (selected_stream == -1) {
+        selected_stream = i;
+      } else {
+        AUBIO_WRN("More than one audio stream in %s, taking the first one\n", s->path);
+      }
+    }
+  }
+  if (selected_stream == -1) {
+    AUBIO_ERR("No audio stream in %s\n", s->path);
+    goto beach;
+  }
+  //AUBIO_DBG("Taking stream %d in file %s\n", selected_stream, s->path);
+  s->selected_stream = selected_stream;
+
+  AVCodecContext *avCodecCtx = s->avCodecCtx;
+  avCodecCtx = avFormatCtx->streams[selected_stream]->codec;
+  AVCodec *codec = avcodec_find_decoder(avCodecCtx->codec_id);
+  if (codec == NULL) {
+    AUBIO_ERR("Could not find decoder for %s", s->path);
+    goto beach;
+  }
+
+  if ( ( err = avcodec_open2(avCodecCtx, codec, NULL) ) < 0) {
+    uint8_t errorstr_len = 128;
+    char errorstr[errorstr_len];
+    if (av_strerror (err, errorstr, errorstr_len) == 0) {
+      AUBIO_ERR("Could not load codec for %s (%s)\n", s->path, errorstr);
+    } else {
+      AUBIO_ERR("Could not load codec for %s (unknown error)\n", s->path);
+    }
+    goto beach;
+  }
+
+  /* get input specs */
+  s->input_samplerate = avCodecCtx->sample_rate;
+  s->input_channels   = avCodecCtx->channels;
+  //AUBIO_DBG("input_samplerate: %d\n", s->input_samplerate);
+  //AUBIO_DBG("input_channels: %d\n", s->input_channels);
+
+  if (samplerate == 0) {
+    samplerate = s->input_samplerate;
+    //AUBIO_DBG("sampling rate set to 0, automagically adjusting to %d\n", samplerate);
+  }
+  s->samplerate = samplerate;
+
+  int64_t input_layout = av_get_default_channel_layout(s->input_channels);
+  int64_t mono_layout = av_get_default_channel_layout(1);
+
+  AVAudioResampleContext *avr = s->avr;
+  avr = avresample_alloc_context();
+  av_opt_set_int(avr, "in_channel_layout",  input_layout,           0);
+  av_opt_set_int(avr, "out_channel_layout", mono_layout,            0);
+  av_opt_set_int(avr, "in_sample_rate",     s->input_samplerate,    0);
+  av_opt_set_int(avr, "out_sample_rate",    s->samplerate,          0);
+  av_opt_set_int(avr, "in_sample_fmt",      avCodecCtx->sample_fmt, 0);
+  av_opt_set_int(avr, "out_sample_fmt",     AV_SAMPLE_FMT_S16,      0);
+  if ( ( err = avresample_open(avr) ) < 0) {
+    uint8_t errorstr_len = 128;
+    char errorstr[errorstr_len];
+    if (av_strerror (err, errorstr, errorstr_len) == 0) {
+      AUBIO_ERR("Could not open AVAudioResampleContext for %s (%s)\n", s->path, errorstr);
+    } else {
+      AUBIO_ERR("Could not open AVAudioResampleContext for %s (unknown error)\n", s->path);
+    }
+    goto beach;
+  }
+
+  AVFrame *avFrame = s->avFrame;
+  avFrame = avcodec_alloc_frame();
+  if (!avFrame) {
+    AUBIO_ERR("Could not allocate frame for (%s)\n", s->path);
+  }
+
+  /* allocate output for avr */
+  s->output = (int16_t *)av_malloc(AUBIO_AVCODEC_MIN_BUFFER_SIZE * sizeof(int16_t));
+
+  s->read_samples = 0;
+  s->read_index = 0;
+
+  s->avFormatCtx = avFormatCtx;
+  s->avCodecCtx = avCodecCtx;
+  s->avFrame = avFrame;
+  s->avr = avr;
+
+  s->eof = 0;
+
+  //av_log_set_level(AV_LOG_QUIET);
+
+  return s;
+
+beach:
+  AUBIO_ERR("can not read %s at samplerate %dHz with a hop_size of %d\n",
+      s->path, s->samplerate, s->hop_size);
+  del_aubio_source_avcodec(s);
+  return NULL;
+}
+
+void aubio_source_avcodec_readframe(aubio_source_avcodec_t *s, uint_t * read_samples) {
+  AVFormatContext *avFormatCtx = s->avFormatCtx;
+  AVCodecContext *avCodecCtx = s->avCodecCtx;
+  AVFrame *avFrame = s->avFrame;
+  AVPacket avPacket;
+  av_init_packet (&avPacket);
+  AVAudioResampleContext *avr = s->avr;
+  int16_t *output = s->output;
+
+  do
+  {
+    int err = av_read_frame (avFormatCtx, &avPacket);
+    if (err != 0) {
+      if (err == AVERROR_EOF) {
+        s->eof = 1;
+        *read_samples = 0;
+        return;
+      }
+      uint8_t errorstr_len = 128;
+      char errorstr[errorstr_len];
+      if (av_strerror (err, errorstr, errorstr_len) == 0) {
+        AUBIO_ERR("Could not read frame in %s (%s)\n", s->path, errorstr);
+      } else {
+        AUBIO_ERR("Could not read frame in %s (unknown error)\n", s->path);
+      }
+      *read_samples = 0;
+      return;
+    }
+  } while (avPacket.stream_index != s->selected_stream);
+
+  int got_frame = 0;
+  int len = avcodec_decode_audio4(avCodecCtx, avFrame, &got_frame, &avPacket);
+
+  if (len < 0) {
+    av_free_packet(&avPacket);
+    AUBIO_ERR("Error while decoding %s\n", s->path);
+    return;
+  }
+  if (got_frame == 0) {
+    av_free_packet(&avPacket);
+    //AUBIO_ERR("Could not get frame for (%s)\n", s->path);
+    *read_samples = 0;
+    return;
+  } /* else {
+    int data_size =
+      av_samples_get_buffer_size(NULL,
+        avCodecCtx->channels, avFrame->nb_samples,
+        avCodecCtx->sample_fmt, 1);
+    AUBIO_WRN("Got data_size %d frame for (%s)\n", data_size, s->path);
+  } */
+
+  int in_samples = avFrame->nb_samples;
+  int in_plane_size = 0; //avFrame->linesize[0];
+  int out_plane_size = 0; //sizeof(float); //in_samples * sizeof(float);
+  int max_out_samples = AUBIO_AVCODEC_MIN_BUFFER_SIZE;
+  uint_t out_samples = avresample_convert ( avr,
+        (uint8_t **)&output, out_plane_size, max_out_samples,
+        (uint8_t **)avFrame->data, in_plane_size, in_samples);
+  if (out_samples < 0) {
+      AUBIO_ERR("Could not convert frame  (%s)\n", s->path);
+      *read_samples = 0;
+  }
+  //AUBIO_ERR("Got in_plane_size %d frame for (%s)\n", in_plane_size, s->path);
+  //AUBIO_WRN("Delay is %d for %s\n", avresample_get_delay(avr), s->path);
+  //AUBIO_WRN("max_out_samples is %d for AUBIO_AVCODEC_MIN_BUFFER_SIZE %d\n",
+  //    max_out_samples, AUBIO_AVCODEC_MIN_BUFFER_SIZE);
+
+  //AUBIO_WRN("aubio_source_avcodec_readframe converted %d to %d samples\n", in_samples, out_samples);
+  //for (i = 0; i < out_samples; i ++) {
+  //  AUBIO_DBG("%f\n", SHORT_TO_FLOAT(output[i]));
+  //}
+  av_free_packet(&avPacket);
+  s->avFormatCtx = avFormatCtx;
+  s->avCodecCtx = avCodecCtx;
+  s->avFrame = avFrame;
+  s->avr = avr;
+  s->output = output;
+
+  *read_samples = out_samples;
+}
+
+
+void aubio_source_avcodec_do(aubio_source_avcodec_t * s, fvec_t * read_data, uint_t * read){
+  uint_t i;
+  uint_t end = 0;
+  uint_t total_wrote = 0;
+  while (total_wrote < s->hop_size) {
+    end = MIN(s->read_samples - s->read_index, s->hop_size - total_wrote);
+    for (i = 0; i < end; i++) {
+      read_data->data[i + total_wrote] = SHORT_TO_FLOAT(s->output[i + s->read_index]);
+    }
+    total_wrote += end;
+    if (total_wrote < s->hop_size) {
+      uint_t avcodec_read = 0;
+      aubio_source_avcodec_readframe(s, &avcodec_read);
+      s->read_samples = avcodec_read;
+      s->read_index = 0;
+      if (s->eof) {
+        break;
+      }
+    } else {
+      s->read_index += end;
+    }
+  }
+  if (total_wrote < s->hop_size) {
+    for (i = end; i < s->hop_size; i++) {
+      read_data->data[i] = 0.;
+    }
+  }
+  *read = total_wrote;
+}
+
+void aubio_source_avcodec_do_multi(aubio_source_avcodec_t * s, fmat_t * read_data, uint_t * read){
+  //uint_t i,j, input_channels = s->input_channels;
+}
+
+uint_t aubio_source_avcodec_get_samplerate(aubio_source_avcodec_t * s) {
+  return s->samplerate;
+}
+
+uint_t aubio_source_avcodec_get_channels(aubio_source_avcodec_t * s) {
+  return s->input_channels;
+}
+
+uint_t aubio_source_avcodec_seek (aubio_source_avcodec_t * s, uint_t pos) {
+  //uint_t resampled_pos = (uint_t)ROUND(pos * s->input_samplerate * 1. / s->samplerate);
+  return 0; //sf_seek (s->handle, resampled_pos, SEEK_SET);
+}
+
+void del_aubio_source_avcodec(aubio_source_avcodec_t * s){
+  if (!s) return;
+  if (s->output != NULL) {
+    av_free(s->output);
+  }
+  if (s->avr != NULL) {
+    avresample_close( s->avr );
+    av_free ( s->avr );
+  }
+  s->avr = NULL;
+  if (s->avFrame != NULL) {
+    avcodec_free_frame( &(s->avFrame) );
+  }
+  s->avFrame = NULL;
+  if (s->avCodecCtx != NULL) {
+    avcodec_close ( s->avCodecCtx );
+  }
+  s->avCodecCtx = NULL;
+  if (s->avFormatCtx != NULL) {
+    avformat_close_input ( &(s->avFormatCtx) );
+  }
+  s->avFrame = NULL;
+  s->avFormatCtx = NULL;
+  AUBIO_FREE(s);
+}
+
+#endif /* HAVE_SNDFILE */
Index: src/io/source_avcodec.h
===================================================================
--- src/io/source_avcodec.h	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
+++ src/io/source_avcodec.h	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
@@ -0,0 +1,134 @@
+/*
+  Copyright (C) 2013 Paul Brossier <piem@aubio.org>
+
+  This file is part of aubio.
+
+  aubio is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
+
+  aubio is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with aubio.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+#ifndef _AUBIO_SOURCE_AVCODEC_H
+#define _AUBIO_SOURCE_AVCODEC_H
+
+/** \file
+
+  Read from file using [libavcodec](http://libav.org/)
+
+  Avoid including this file directly! Prefer using ::aubio_source_t instead to
+  make your code portable.
+
+  To write to file, use ::aubio_sink_t.
+
+  \example io/test-source_avcodec.c
+
+*/
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/** avcodec media source object */
+typedef struct _aubio_source_avcodec_t aubio_source_avcodec_t;
+
+/**
+
+  create new ::aubio_source_avcodec_t
+
+  \param uri the file path or uri to read from
+  \param samplerate sampling rate to view the fie at
+  \param hop_size the size of the blocks to read from
+
+  Creates a new source object. If `0` is passed as `samplerate`, the sample
+  rate of the original file is used.
+
+  The samplerate of newly created source can be obtained using
+  ::aubio_source_avcodec_get_samplerate.
+
+*/
+aubio_source_avcodec_t * new_aubio_source_avcodec(char_t * uri, uint_t samplerate, uint_t hop_size);
+
+/**
+
+  read monophonic vector of length hop_size from source object
+
+  \param s source object, created with ::new_aubio_source_avcodec
+  \param read_to ::fvec_t of data to read to
+  \param read upon returns, equals to number of frames actually read
+
+  Upon returns, `read` contains the number of frames actually read from the
+  source. `hop_size` if enough frames could be read, less otherwise.
+
+*/
+void aubio_source_avcodec_do(aubio_source_avcodec_t * s, fvec_t * read_to, uint_t * read);
+
+/**
+
+  read polyphonic vector of length hop_size from source object
+
+  \param s source object, created with ::new_aubio_source_avcodec
+  \param read_to ::fmat_t of data to read to
+  \param read upon returns, equals to number of frames actually read
+
+  Upon returns, `read` contains the number of frames actually read from the
+  source. `hop_size` if enough frames could be read, less otherwise.
+
+*/
+void aubio_source_avcodec_do_multi(aubio_source_avcodec_t * s, fmat_t * read_to, uint_t * read);
+
+/**
+
+  get samplerate of source object
+
+  \param s source object, created with ::new_aubio_source_avcodec
+  \return samplerate, in Hz
+
+*/
+uint_t aubio_source_avcodec_get_samplerate(aubio_source_avcodec_t * s);
+
+/**
+
+  get number of channels of source object
+
+  \param s source object, created with ::new_aubio_source_avcodec
+  \return number of channels
+
+*/
+uint_t aubio_source_avcodec_get_channels (aubio_source_avcodec_t * s);
+
+/**
+
+  seek source object
+
+  \param s source object, created with ::new_aubio_source_avcodec
+  \param pos position to seek to, in frames
+
+  \return 0 if sucessful, non-zero on failure
+
+*/
+uint_t aubio_source_avcodec_seek (aubio_source_avcodec_t *s, uint_t pos);
+
+/**
+
+  close source and cleanup memory
+
+  \param s source object, created with ::new_aubio_source_avcodec
+
+*/
+void del_aubio_source_avcodec(aubio_source_avcodec_t * s);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _AUBIO_SOURCE_AVCODEC_H */
Index: src/io/source_sndfile.c
===================================================================
--- src/io/source_sndfile.c	(revision 52b5f34a17f85e61db57d23ab0b3c6489da862bb)
+++ src/io/source_sndfile.c	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
@@ -74,5 +74,5 @@
   s->path = path;
 
-  // try opening the file, geting the info in sfinfo
+  // try opening the file, getting the info in sfinfo
   SF_INFO sfinfo;
   AUBIO_MEMSET(&sfinfo, 0, sizeof (sfinfo));
Index: src/wscript_build
===================================================================
--- src/wscript_build	(revision 52b5f34a17f85e61db57d23ab0b3c6489da862bb)
+++ src/wscript_build	(revision af272654dfc3b6b37ba4a21ee354074ec7721901)
@@ -6,4 +6,8 @@
 uselib += ['SAMPLERATE']
 uselib += ['SNDFILE']
+uselib += ['AVCODEC']
+uselib += ['AVFORMAT']
+uselib += ['AVRESAMPLE']
+uselib += ['AVUTIL']
 uselib += ['JACK']
 uselib += ['LASH']
